apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "catalogservice.fullname" . }}
  labels:
{{ include "catalogservice.labels" . | indent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ include "catalogservice.name" . }}
      app.kubernetes.io/instance: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ include "catalogservice.name" . }}
        app.kubernetes.io/instance: {{ .Release.Name }}
    spec:
      imagePullSecrets:
        - name: {{ .Values.imageCredentials.name }}
    # {{- with .Values.imagePullSecrets }}
    #   imagePullSecrets:
    #     {{- toYaml . | nindent 8 }}
    # {{- end }}
      initContainers:
        - name: init-wait-for-mongo
          image: busybox:1.28
          command: ['sh', '-c', 'until nslookup catalogdb; do echo waiting for catalogdb; sleep 2; done;']
      containers:
        - name: {{ .Chart.Name }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          env:
           - name: DB_HOST
             value: {{ .Values.env.db_host }}
           - name: DB_PORT
             value: {{ .Values.env.db_port | quote }}
          livenessProbe:
            httpGet:
              path: /api/training
              port: http
          readinessProbe:
            httpGet:
              path: /api/training
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
